/* dzl-progress-icon.h
 *
 * Copyright (C) 2016 Christian Hergert <chergert@redhat.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DZL_PROGRESS_ICON_H
#define DZL_PROGRESS_ICON_H

#include <gtk/gtk.h>

#include "dzl-version-macros.h"

G_BEGIN_DECLS

#define DZL_TYPE_PROGRESS_ICON (dzl_progress_icon_get_type())

DZL_AVAILABLE_IN_ALL
G_DECLARE_FINAL_TYPE (DzlProgressIcon, dzl_progress_icon, DZL, PROGRESS_ICON, GtkDrawingArea)

DZL_AVAILABLE_IN_ALL
GtkWidget *dzl_progress_icon_new          (void);
DZL_AVAILABLE_IN_ALL
gdouble    dzl_progress_icon_get_progress (DzlProgressIcon *self);
DZL_AVAILABLE_IN_ALL
void       dzl_progress_icon_set_progress (DzlProgressIcon *self,
                                           gdouble          progress);

G_END_DECLS

#endif /* DZL_PROGRESS_ICON_H */
